(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 12.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     16370,        481]
NotebookOptionsPosition[     15603,        461]
NotebookOutlinePosition[     15998,        477]
CellTagsIndexPosition[     15955,        474]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[{
 RowBox[{
  RowBox[{"jerkProfileUDDU", "=", 
   RowBox[{"{", 
    RowBox[{"jMax", ",", "0", ",", 
     RowBox[{"-", "jMax"}], ",", "0", ",", 
     RowBox[{"-", "jMax"}], ",", "0", ",", "jMax"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"jerkProfileUDUD", "=", 
    RowBox[{"{", 
     RowBox[{"jMax", ",", "0", ",", 
      RowBox[{"-", "jMax"}], ",", "0", ",", "jMax", ",", "0", ",", 
      RowBox[{"-", "jMax"}]}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"jerkProfile", "=", "jerkProfileUDUD"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a1", "=", 
   RowBox[{"a0", "+", 
    RowBox[{"t1", " ", 
     RowBox[{"jerkProfile", "[", 
      RowBox[{"[", "1", "]"}], "]"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a2", "=", 
   RowBox[{"a1", "+", 
    RowBox[{"t2", " ", 
     RowBox[{"jerkProfile", "[", 
      RowBox[{"[", "2", "]"}], "]"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a3", "=", 
   RowBox[{"a2", "+", 
    RowBox[{"t3", " ", 
     RowBox[{"jerkProfile", "[", 
      RowBox[{"[", "3", "]"}], "]"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a4", "=", 
   RowBox[{"a3", "+", 
    RowBox[{"t4", " ", 
     RowBox[{"jerkProfile", "[", 
      RowBox[{"[", "4", "]"}], "]"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a5", "=", 
   RowBox[{"a4", "+", 
    RowBox[{"t5", " ", 
     RowBox[{"jerkProfile", "[", 
      RowBox[{"[", "5", "]"}], "]"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a6", "=", 
   RowBox[{"a5", "+", 
    RowBox[{"t6", " ", 
     RowBox[{"jerkProfile", "[", 
      RowBox[{"[", "6", "]"}], "]"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"a7", "=", 
    RowBox[{"a6", "+", 
     RowBox[{"t7", " ", 
      RowBox[{"jerkProfile", "[", 
       RowBox[{"[", "7", "]"}], "]"}]}]}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"v1", "=", 
   RowBox[{"v0", "+", 
    RowBox[{"t1", " ", "a0"}], "+", 
    RowBox[{
     FractionBox["1", "2"], 
     SuperscriptBox["t1", "2"], 
     RowBox[{"jerkProfile", "[", 
      RowBox[{"[", "1", "]"}], "]"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"v2", "=", 
   RowBox[{"v1", "+", 
    RowBox[{"t2", " ", "a1"}], "+", 
    RowBox[{
     FractionBox["1", "2"], 
     SuperscriptBox["t2", "2"], 
     RowBox[{"jerkProfile", "[", 
      RowBox[{"[", "2", "]"}], "]"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"v3", "=", 
   RowBox[{"v2", "+", 
    RowBox[{"t3", " ", "a2"}], "+", 
    RowBox[{
     FractionBox["1", "2"], 
     SuperscriptBox["t3", "2"], 
     RowBox[{"jerkProfile", "[", 
      RowBox[{"[", "3", "]"}], "]"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"v4", "=", 
   RowBox[{"v3", "+", 
    RowBox[{"t4", " ", "a3"}], "+", 
    RowBox[{
     FractionBox["1", "2"], 
     SuperscriptBox["t4", "2"], 
     RowBox[{"jerkProfile", "[", 
      RowBox[{"[", "4", "]"}], "]"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"v5", "=", 
   RowBox[{"v4", "+", 
    RowBox[{"t5", " ", "a4"}], "+", 
    RowBox[{
     FractionBox["1", "2"], 
     SuperscriptBox["t5", "2"], 
     RowBox[{"jerkProfile", "[", 
      RowBox[{"[", "5", "]"}], "]"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"v6", "=", 
   RowBox[{"v5", "+", 
    RowBox[{"t6", " ", "a5"}], "+", 
    RowBox[{
     FractionBox["1", "2"], 
     SuperscriptBox["t6", "2"], 
     RowBox[{"jerkProfile", "[", 
      RowBox[{"[", "6", "]"}], "]"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"v7", "=", 
    RowBox[{"v6", "+", 
     RowBox[{"t7", " ", "a6"}], "+", 
     RowBox[{
      FractionBox["1", "2"], 
      SuperscriptBox["t7", "2"], 
      RowBox[{"jerkProfile", "[", 
       RowBox[{"[", "7", "]"}], "]"}]}]}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"p1", "=", 
   RowBox[{"p0", "+", 
    RowBox[{"t1", " ", "v0"}], "+", 
    RowBox[{
     FractionBox["1", "2"], 
     SuperscriptBox["t1", "2"], " ", "a0"}], "+", 
    RowBox[{
     FractionBox["1", "6"], 
     SuperscriptBox["t1", "3"], 
     RowBox[{"jerkProfile", "[", 
      RowBox[{"[", "1", "]"}], "]"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"p2", "=", 
   RowBox[{"p1", "+", 
    RowBox[{"t2", " ", "v1"}], "+", 
    RowBox[{
     FractionBox["1", "2"], 
     SuperscriptBox["t2", "2"], " ", "a1"}], "+", 
    RowBox[{
     FractionBox["1", "6"], 
     SuperscriptBox["t2", "3"], 
     RowBox[{"jerkProfile", "[", 
      RowBox[{"[", "2", "]"}], "]"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"p3", "=", 
   RowBox[{"p2", "+", 
    RowBox[{"t3", " ", "v2"}], "+", 
    RowBox[{
     FractionBox["1", "2"], 
     SuperscriptBox["t3", "2"], " ", "a2"}], "+", 
    RowBox[{
     FractionBox["1", "6"], 
     SuperscriptBox["t3", "3"], 
     RowBox[{"jerkProfile", "[", 
      RowBox[{"[", "3", "]"}], "]"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"p4", "=", 
   RowBox[{"p3", "+", 
    RowBox[{"t4", " ", "v3"}], "+", 
    RowBox[{
     FractionBox["1", "2"], 
     SuperscriptBox["t4", "2"], " ", "a3"}], "+", 
    RowBox[{
     FractionBox["1", "6"], 
     SuperscriptBox["t4", "3"], 
     RowBox[{"jerkProfile", "[", 
      RowBox[{"[", "4", "]"}], "]"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"p5", "=", 
   RowBox[{"p4", "+", 
    RowBox[{"t5", " ", "v4"}], "+", 
    RowBox[{
     FractionBox["1", "2"], 
     SuperscriptBox["t5", "2"], " ", "a4"}], "+", 
    RowBox[{
     FractionBox["1", "6"], 
     SuperscriptBox["t5", "3"], 
     RowBox[{"jerkProfile", "[", 
      RowBox[{"[", "5", "]"}], "]"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"p6", "=", 
   RowBox[{"p5", "+", 
    RowBox[{"t6", " ", "v5"}], "+", 
    RowBox[{
     FractionBox["1", "2"], 
     SuperscriptBox["t6", "2"], " ", "a5"}], "+", 
    RowBox[{
     FractionBox["1", "6"], 
     SuperscriptBox["t6", "3"], 
     RowBox[{"jerkProfile", "[", 
      RowBox[{"[", "6", "]"}], "]"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"p7", "=", 
    RowBox[{"p6", "+", 
     RowBox[{"t7", " ", "v6"}], "+", 
     RowBox[{
      FractionBox["1", "2"], 
      SuperscriptBox["t7", "2"], " ", "a6"}], "+", 
     RowBox[{
      FractionBox["1", "6"], 
      SuperscriptBox["t7", "3"], 
      RowBox[{"jerkProfile", "[", 
       RowBox[{"[", "7", "]"}], "]"}]}]}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tAll", "=", 
   RowBox[{
   "t1", "+", "t2", "+", "t3", "+", "t4", "+", "t5", "+", "t6", "+", "t7"}]}],
   ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tVars", "=", 
   RowBox[{"{", 
    RowBox[{
    "t1", ",", "t2", ",", "t3", ",", "t4", ",", "t5", ",", "t6", ",", "t7"}], 
    "}"}]}], ";"}]}], "Input",
 CellChangeTimes->{3.819602008191699*^9},
 CellLabel->"In[7]:=",ExpressionUUID->"099a8ff3-0e49-4a08-b964-3c54b7f9002d"],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.819561618200523*^9, 
  3.8195616479009237`*^9}},ExpressionUUID->"ab8196f4-4496-4301-8655-\
17a49063bd9d"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"tmp", "=", 
  RowBox[{"Simplify", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"p7", "-", "pf"}], ")"}], "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"t1", "\[Rule]", "0"}], ",", 
       RowBox[{"t2", "\[Rule]", "0"}], ",", 
       RowBox[{"t3", "\[Rule]", "t"}], ",", 
       RowBox[{"t6", "\[Rule]", "0"}], ",", 
       RowBox[{"t7", "\[Rule]", 
        RowBox[{"tf", "-", 
         RowBox[{"(", 
          RowBox[{"t", "+", "t4", "+", "t5"}], ")"}]}]}]}], "}"}]}], "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"t4", "\[Rule]", 
       RowBox[{"(", 
        RowBox[{"tf", "-", 
         RowBox[{"2", "t"}], "-", 
         FractionBox[
          RowBox[{"(", 
           RowBox[{"af", "-", "a0"}], ")"}], "jMax"], "-", 
         RowBox[{
          RowBox[{"Sqrt", "[", 
           RowBox[{"(", 
            RowBox[{"2", "*", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["a0", "2"], "+", 
               SuperscriptBox["af", "2"], "+", 
               RowBox[{"2", "af", " ", "jMax", " ", "t"}], "-", 
               RowBox[{"2", "a0", 
                RowBox[{"(", 
                 RowBox[{"af", "+", 
                  RowBox[{"jMax", 
                   RowBox[{"(", 
                    RowBox[{"t", "-", "tf"}], ")"}]}]}], ")"}]}], "+", 
               RowBox[{"2", "jMax", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"jMax", " ", "t", 
                   RowBox[{"(", 
                    RowBox[{"t", "-", "tf"}], ")"}]}], "-", "vd"}], ")"}]}]}],
               ")"}]}], ")"}], "]"}], "/", 
          RowBox[{"(", 
           RowBox[{"Abs", "[", "jMax", "]"}], ")"}]}]}], ")"}]}], ",", 
      RowBox[{"t5", "->", 
       RowBox[{
        RowBox[{"Sqrt", "[", 
         RowBox[{"(", 
          RowBox[{"2", "*", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a0", "2"], "+", 
             SuperscriptBox["af", "2"], "+", 
             RowBox[{"2", "af", " ", "jMax", " ", "t"}], "-", 
             RowBox[{"2", "a0", 
              RowBox[{"(", 
               RowBox[{"af", "+", 
                RowBox[{"jMax", 
                 RowBox[{"(", 
                  RowBox[{"t", "-", "tf"}], ")"}]}]}], ")"}]}], "+", 
             RowBox[{"2", "jMax", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"jMax", " ", "t", 
                 RowBox[{"(", 
                  RowBox[{"t", "-", "tf"}], ")"}]}], "-", "vd"}], ")"}]}]}], 
            ")"}]}], ")"}], "]"}], "/", 
        RowBox[{"(", 
         RowBox[{"2", 
          RowBox[{"Abs", "[", "jMax", "]"}]}], ")"}]}]}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"ToString", "[", 
  RowBox[{
   RowBox[{"Simplify", "[", "tmp", "]"}], ",", "CForm"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"CopyToClipboard", "[", "%", "]"}]}], "Input",
 CellChangeTimes->{{3.81956156377069*^9, 3.819561609073489*^9}, {
  3.8195616490010757`*^9, 3.819561880668848*^9}, {3.8195620220367327`*^9, 
  3.819562023947276*^9}, {3.8195621217573977`*^9, 3.8195621358064003`*^9}, {
  3.819562230757843*^9, 3.819562249667959*^9}},
 CellLabel->"In[98]:=",ExpressionUUID->"58da9551-5167-44e7-a65b-195023eb5f56"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox["1", 
    RowBox[{"6", " ", 
     SuperscriptBox["jMax", "2"]}]], 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      SuperscriptBox["a0", "3"]}], "+", 
     SuperscriptBox["af", "3"], "+", 
     RowBox[{"3", " ", 
      SuperscriptBox["af", "2"], " ", "jMax", " ", "t"}], "+", 
     RowBox[{"3", " ", "af", " ", 
      SuperscriptBox["jMax", "2"], " ", 
      SuperscriptBox["t", "2"]}], "+", 
     RowBox[{"3", " ", 
      SuperscriptBox["a0", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"af", "+", 
        RowBox[{"jMax", " ", "t"}]}], ")"}]}], "-", 
     RowBox[{"3", " ", "a0", " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["af", "2"], "+", 
        RowBox[{"2", " ", "af", " ", "jMax", " ", "t"}], "+", 
        RowBox[{
         SuperscriptBox["jMax", "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox["t", "2"], "-", 
           SuperscriptBox["tf", "2"]}], ")"}]}]}], ")"}]}], "+", 
     RowBox[{"3", " ", 
      SuperscriptBox["jMax", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2", " ", "p0"}], "-", 
        RowBox[{"2", " ", "pf"}], "+", 
        RowBox[{"jMax", " ", "t", " ", 
         RowBox[{"(", 
          RowBox[{"t", "-", "tf"}], ")"}], " ", "tf"}], "+", 
        RowBox[{"2", " ", "tf", " ", "v0"}]}], ")"}]}]}], ")"}]}], "-", 
  FractionBox[
   RowBox[{"jMax", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["a0", "2"], "+", 
       SuperscriptBox["af", "2"], "+", 
       RowBox[{"2", " ", "af", " ", "jMax", " ", "t"}], "-", 
       RowBox[{"2", " ", "a0", " ", 
        RowBox[{"(", 
         RowBox[{"af", "+", 
          RowBox[{"jMax", " ", 
           RowBox[{"(", 
            RowBox[{"t", "-", "tf"}], ")"}]}]}], ")"}]}], "+", 
       RowBox[{"2", " ", "jMax", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"jMax", " ", "t", " ", 
           RowBox[{"(", 
            RowBox[{"t", "-", "tf"}], ")"}]}], "-", "vd"}], ")"}]}]}], ")"}], 
     
     RowBox[{"3", "/", "2"}]]}], 
   RowBox[{"2", " ", 
    SqrtBox["2"], " ", 
    SuperscriptBox[
     RowBox[{"Abs", "[", "jMax", "]"}], "3"]}]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{"a0", "-", "af", "-", 
      RowBox[{"jMax", " ", "t"}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox["a0", "2"], "+", 
      SuperscriptBox["af", "2"], "+", 
      RowBox[{"2", " ", "af", " ", "jMax", " ", "t"}], "-", 
      RowBox[{"2", " ", "a0", " ", 
       RowBox[{"(", 
        RowBox[{"af", "+", 
         RowBox[{"jMax", " ", 
          RowBox[{"(", 
           RowBox[{"t", "-", "tf"}], ")"}]}]}], ")"}]}], "+", 
      RowBox[{"2", " ", "jMax", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"jMax", " ", "t", " ", 
          RowBox[{"(", 
           RowBox[{"t", "-", "tf"}], ")"}]}], "-", "vd"}], ")"}]}]}], ")"}]}], 
   RowBox[{"2", " ", 
    SuperscriptBox[
     RowBox[{"Abs", "[", "jMax", "]"}], "2"]}]]}]], "Output",
 CellChangeTimes->{{3.819561649749753*^9, 3.8195616568809767`*^9}, {
   3.819561697059889*^9, 3.819561735670363*^9}, 3.8195617682059298`*^9, {
   3.81956180497314*^9, 3.819561881074012*^9}, {3.819562016223662*^9, 
   3.819562024427198*^9}, {3.8195621277446213`*^9, 3.819562136285375*^9}, {
   3.8195622332578373`*^9, 3.819562251052745*^9}},
 CellLabel->"Out[98]=",ExpressionUUID->"6db2ca46-5d56-4204-a972-d02ff6728af7"],

Cell[BoxData["\<\"(-Power(a0,3) + Power(af,3) + 3*Power(af,2)*jMax*t + \
3*af*Power(jMax,2)*Power(t,2) + 3*Power(a0,2)*(af + jMax*t) - \
3*a0*(Power(af,2) + 2*af*jMax*t + Power(jMax,2)*(Power(t,2) - Power(tf,2))) + \
3*Power(jMax,2)*(2*p0 - 2*pf + jMax*t*(t - tf)*tf + \
2*tf*v0))/(6.*Power(jMax,2)) - (jMax*Power(Power(a0,2) + Power(af,2) + \
2*af*jMax*t - 2*a0*(af + jMax*(t - tf)) + 2*jMax*(jMax*t*(t - tf) - \
vd),1.5))/(2.*Sqrt(2)*Power(Abs(jMax),3)) + ((a0 - af - jMax*t)*(Power(a0,2) \
+ Power(af,2) + 2*af*jMax*t - 2*a0*(af + jMax*(t - tf)) + 2*jMax*(jMax*t*(t - \
tf) - vd)))/(2.*Power(Abs(jMax),2))\"\>"], "Output",
 CellChangeTimes->{{3.819561649749753*^9, 3.8195616568809767`*^9}, {
   3.819561697059889*^9, 3.819561735670363*^9}, 3.8195617682059298`*^9, {
   3.81956180497314*^9, 3.819561881074012*^9}, {3.819562016223662*^9, 
   3.819562024427198*^9}, {3.8195621277446213`*^9, 3.819562136285375*^9}, {
   3.8195622332578373`*^9, 3.819562251091281*^9}},
 CellLabel->"Out[99]=",ExpressionUUID->"a5342eb2-cf4b-4562-a3c9-4043e660ac51"]
}, Open  ]]
},
WindowSize->{808, 747},
WindowMargins->{{Automatic, 139}, {Automatic, 101}},
FrontEndVersion->"12.1 for Mac OS X x86 (64-bit) (June 19, 2020)",
StyleDefinitions->"Default.nb",
ExpressionUUID->"fa4eca22-4fcd-44eb-91d3-fdc0150e5310"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 7089, 227, 919, "Input",ExpressionUUID->"099a8ff3-0e49-4a08-b964-3c54b7f9002d"],
Cell[7650, 249, 154, 3, 30, "Input",ExpressionUUID->"ab8196f4-4496-4301-8655-17a49063bd9d"],
Cell[CellGroupData[{
Cell[7829, 256, 3250, 86, 307, "Input",ExpressionUUID->"58da9551-5167-44e7-a65b-195023eb5f56"],
Cell[11082, 344, 3457, 98, 178, "Output",ExpressionUUID->"6db2ca46-5d56-4204-a972-d02ff6728af7"],
Cell[14542, 444, 1045, 14, 182, "Output",ExpressionUUID->"a5342eb2-cf4b-4562-a3c9-4043e660ac51"]
}, Open  ]]
}
]
*)

